import { observable } from 'mobx'
import { createMpApp } from '@cloudbase/weda-client';
import { createComputed, formatEnum, enumOptions} from '<%= subLevelPath %>../common/util'
import process from '<%= subLevelPath %>../common/process'
import appGlobal from '<%= subLevelPath %>../app/app-global'
import { CLOUD_SDK, createDataset, EXTRA_API } from '<%= subLevelPath %>../datasources/index'


<% if (!isBare) {%>
import state from '../lowcode/state'
import computed from '../lowcode/computed'
import common from './common'
<%} else {%>
const state = {}
const computed ={}
const common = {}
<%}%>

const mainAppKey = '__weappsMainApp'

export const app = createGlboalApi()
export { process }

function createGlboalApi() {
  const mpApp = createMpApp({
    appConfig: <%= appConfig %>
  })
  const globalAPI = {
    id: '<%= appId %>',
    domain: '<%= domain %>',
    platform: 'MINIPROGRAME',
    pages: {},
    session: {
      //configure: sdk.configure,
      //request: sdk.request,
      //getSessionId: sdk.getSessionId,
    },
    state: observable(state),
    computed: createComputed(computed),
    common,
    invoke(params) {
      return app.__internal__.activePage.invokeComponentMethod(params)
    },
    ...mpApp,
  } // The global api exposed to lowcode


  globalAPI.__internal__.enumOptions = enumOptions
  globalAPI.utils.formatEnum = formatEnum
  /**
   * @deprecated utils._getConfig
   */
  globalAPI.utils._getConfig = () => {
    return globalAPI.__internal__.getConfig()
  }
  globalAPI.utils.getWXContext = async function() {
    const { Data } = await globalAPI.cloud.callWedaApi({
      action: 'InvokeComponentWxModule',
      data: {
        Method: 'GetWxContext',
      },
    });
    return typeof Data === 'string' ? JSON.parse(Data) : Data
  }

  let dataset = createDataset('$global')
  globalAPI.dataset = dataset
  globalAPI.state.dataset = dataset
  globalAPI.setState = (userSetState) => {
    Object.keys(userSetState).forEach((keyPath) => {
      globalAPI.utils.set(globalAPI.dataset.state, keyPath, userSetState[keyPath]);
    });
  };

  const subPackageName = '<%= subPackageName %>'
  if (subPackageName) {
    // is sub app
    globalAPI.mainApp = appGlobal[mainAppKey]
    const mpApp = getApp()
    mpApp && (mpApp.subApp = globalAPI)
  } else {
    // is mainApp
    appGlobal[mainAppKey] = globalAPI
  }
  // 避免被wx.cloud 覆盖
  globalAPI.cloud = CLOUD_SDK

  return globalAPI
}
